﻿using AvaloniaApplication2.Models;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace AvaloniaApplication2.ViewModels
{
    internal class AuthVM:ViewModelBase
    {
        string _login = "";
        string _password = "";
        string _message = "";

        public string Login { get => _login; set => _login = value; }
        public string Password { get => _password; set => _password = value; }
        public string Message { get => _message; set => this.RaiseAndSetIfChanged(ref _message, value); }

        public void AutoUser()
        {
            byte[] _hashPassword = MD5.HashData(Encoding.ASCII.GetBytes(_password));
            User user = MainWindowViewModel.myconnection.Users.Include(x => x.RoleNavigation).FirstOrDefault(x => x.Login == _login && x.Password == _hashPassword);
            if (user != null)
            {
                MainWindowViewModel.Instance.Page = new Personal(user);
            }
            else
            {
                Message = "Неверные данные входа";
            }

        }
    }
}
